/*
 * avc.h - An AV/C target class
 *
 * Copyright (C) 2002 Dan Dennedy <dan@dennedy.org>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef AVC_H
#define AVC_H

#include <libraw1394/raw1394.h>
#include <libavc1394/avc1394.h>
#include "iec61883.h"

class AvcTarget {
  private:
    raw1394handle_t m_handle;
    static IEC61883Stream *m_ts;

    static inline void play(avc1394_cmd_rsp * cr, float rate);

  public:
     AvcTarget(raw1394handle_t handle, IEC61883Stream * ts);
    ~AvcTarget(void);

  protected:
    static int subunit_control(avc1394_cmd_rsp * cr);
    static int subunit_status(avc1394_cmd_rsp * cr);
    static int subunit_inquiry(avc1394_cmd_rsp * cr);
    static int unit_control(avc1394_cmd_rsp * cr);
    static int unit_status(avc1394_cmd_rsp * cr);
    static int unit_inquiry(avc1394_cmd_rsp * cr);
    static int command_handler(avc1394_cmd_rsp * cr);
};

#endif
